////////////////////////////////////////////////////////////////////////////////////////////////
//
//  ShadowMap.fx v0.54
//  쐬: f[^P
//
////////////////////////////////////////////////////////////////////////////////////////////////

#include "config.h"

// MMD{sampler㏑Ȃ߂̋LqłB폜sB
sampler MMDSamp0 : register(s0);
sampler MMDSamp1 : register(s1);
sampler MMDSamp2 : register(s2);

#if SOFTSHADOW==SOFTSHADOW_VSM_LARGE
#define SHADOWMAP_MIP 0
#else
#define SHADOWMAP_MIP 1
#endif
shared texture ShadowMap : OFFSCREENRENDERTARGET <
	string Description = "ShadowMap";
	string Format = "D3DFMT_R32F";
	int2 Dimensions = {SHADOWMAP_WIDTH, SHADOWMAP_HEIGHT};
	float4 ClearColor = { 1, 0, 0, 0 };
	float ClearDepth = 1.0;
	bool AntiAlias = false;
	int Miplevels = SHADOWMAP_MIP;
	string DefaultEffect =
	    "self = hide;"
	    "*=ShadowDraw.fx;";
>;

// Ȃ悤ɊeeNjbNׂ
technique Tech0 < string MMDPass = "object"; > { }
technique Tech1 < string MMDPass = "object_ss"; > { }
technique Tech2 < string MMDPass = "zplot"; > { }
technique Tech3 < string MMDPass = "edge"; > { }
technique Tech4 < string MMDPass = "shadow"; > { }

